//Készítette:    Veszprémi Anna
//Dátum:         2018.02.20.
//Prioritásos sor forrás kódja

#include "priorsor.h"

using namespace std;

PrSor::PrSor()
{
    _h=0; _n=size;
    _vec= new Elem[_n];
}

PrSor::PrSor(int m)
{
    if(m<=0) throw HIBAS_MERET;
    _h=0; _n=m;
    _vec=new Elem[_n];
}

void PrSor::prSorba(Elem a)
{
    // ha betelt, új 2-szer akkora helyet foglalunk
    if(_h >= _n)
    {
        Elem* _newVec = new Elem[2*_n];
        _n = 2*_n;
        for(int i=0; i<_h; ++i)
        {
            _newVec[i] = _vec[i];
        }
        // régit töröljük
        delete[] _vec;
        _vec = _newVec;
    }
    // van hely: beírjuk a tömbbe
    _vec[_h++]=a;
}

Elem PrSor::maxKivesz()
{
    if(_h==0) throw URES_PRSOR;
    int ind = maxindex();
    // lementjük a visszaadandó elemet
    Elem max = _vec[ind];
    // utolsó elemet beírjuk a kivett helyére, hogy ne kelljen mindent mozgatni
    _vec[ind] = _vec[_h-1];
    --_h;
    return max;
}

Elem PrSor::max() const
{
    if(_h==0) throw URES_PRSOR;
    int ind = maxindex();
    return _vec[ind];
}

ostream& operator<<(std::ostream& s, const PrSor& q)
{
    s << "\n>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n";
    s << "PrSor jellemzoi:\n";
    s << "A sor merete:" << q._n << " Elemszam:" << q._h << "\nTartalma: " << endl;
    for(int i = 0; i < q._h; ++i){
        s << " (" << q._vec[i].pr << "," << q._vec[i].adat << ")";
    }
    s << "\n>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n\n";
    return s;
}

PrSor::PrSor(const PrSor& q)
{
    // copy konstruktor
    // új memóriát foglalunk, és lemásoljuk a másik objektum adatait
    _h = q._h;
    _n = q._n;
    _vec = new Elem[_n];
    for (int i=0; i<_h; ++i)
        _vec[i] = q._vec[i];
}

PrSor& PrSor::operator=(const PrSor& q)
{
    // értékadó operátor
    // önmagának értékadás: nem akarjuk törölni a memóriát
    if(_vec == q._vec)
    {
        _h = q._h;
        _n = q._n;
    }
    // különben töröljük a régit, és új bufferbe beírjuk az újat
    else
    {
        delete[] _vec;
        _vec = new Elem[q._n];
        for (int i=0; i<q._h; ++i)
            _vec[i] = q._vec[i];
        _h = q._h;
        _n = q._n;
    }
    return *this;
}

int PrSor::maxindex() const
{
    if(_h <= 0) throw URES_PRSOR;
    int maxind = 0;
    //int maxpr = _vec->pr;
    for(int i=1;i<_h;++i)
        if(_vec[i].pr > _vec[maxind].pr)
            maxind = i;
    return maxind;
}

vector<Elem> PrSor::getElemek() const
{
    vector<Elem> v;
    for(int i=0; i<_h; ++i)
        v.push_back(_vec[i]);
    return v;
}
